#!/usr/bin/perl


#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014


use strict;
use warnings;
use DBI;

my $SQLite_file = shift @ARGV;
my $interval = shift @ARGV;
my $dbh2 = DBI->connect("dbi:SQLite:dbname=$SQLite_file",'','',{AutoCommit=>0, RaiseError=>1});
my $sth2 = $dbh2->prepare("SELECT FORMULA from molecules");
$sth2->execute;
my $total = 0;
while ( my $row = $sth2->fetchrow_array )
  {
  $total++;
  }
my $limit = 0;
$dbh2->disconnect();

while ( $limit < $total+$interval )
  {
  if ($limit > $total)
    {
    $limit = $total;
    }

  #take n number of formulas in order of ID from DB.
  my $dbh = DBI->connect("dbi:SQLite:dbname=$SQLite_file",'','',{AutoCommit=>0, RaiseError=>1});
  my $string = "SELECT FORMULA from molecules ORDER by ID LIMIT $limit";
  my $sth = $dbh->prepare($string);

  $sth->execute;
  my @result = $sth->fetchrow_array();
  my $formulas = [];
  while ( my $row = $sth->fetchrow_array )
    {
    push @$formulas, $row;
    }
  my %counter;
  foreach my $formula (@$formulas)
    {
    $counter{$formula}++;
    }

  my $total_compounds = 0;
  my $total_formulas = 0;
  my $isomeric_compounds = 0;
  my $isomeric_formulas = 0;
  my $non_isomeric_compounds = 0;
  my $non_isomeric_formulas = 0;


  foreach my $value (values %counter)
    {
    $total_compounds += $value;
    if ($value == 1) #is unique formula
      {
      $non_isomeric_compounds ++;
      $non_isomeric_formulas ++;
      $total_formulas ++;
      }
    elsif ($value > 1) #is not unique formula
      {
      $isomeric_compounds += $value;
      $isomeric_formulas ++;
      $total_formulas ++;
      }
    }
  
  my $percent_iso_formulas = $isomeric_formulas / $total_formulas * 100 if ($limit != 0);
  my $percent_iso_compounds = $isomeric_compounds / $total_compounds * 100 if ($limit != 0);;
  print $limit, "::", $percent_iso_formulas, "::", $percent_iso_compounds, "\n" if ($limit != 0);;

  $limit = $limit + $interval;
  $dbh->disconnect;

  }

$dbh2->disconnect;
