#!/usr/bin/perl


#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014


use strict;
use DBI;

my $stereos = shift @ARGV;
open FILE, $stereos;
my $count = 0;
my $name_1;
my $name_2;
my $stereo;
my %stereos;
my %test;
my $estimate = 0;
#print STDOUT "Reading Stereolist\n";
while (my $line = <FILE>)
  {
  chomp $line;
  if ($count == 0)
    {
    $name_1 = $line;
    $name_1 = "Unknown" if $name_1 eq '';
    $count ++;
    }
  elsif ($count == 1)
    {
    $name_2 = $line;
    $name_2 = "Unknown" if $name_2 eq '';
    $count ++;
    }
  elsif ($count == 2)
    {
    $stereo = $line;
    if ( $stereo == 1 )
      {
      #essentially record the names of stereoisomer pairs for future use
      $estimate ++;
      $test{$name_1} = 1;
      $test{$name_2} = 1;
      $stereos{$name_1}{$name_2} = $stereo;
      $stereos{$name_2}{$name_1} = $stereo;
      }
    $count = 0;
    }
  else
    {
    die "SOMETHING IS WRONG\n";
    }
  }

my @array = keys %test;



my $SQLite_file = shift @ARGV;
my $interval = shift @ARGV;
my $dbh = DBI->connect("dbi:SQLite:dbname=$SQLite_file",'','',{AutoCommit=>0, RaiseError=>1});
my $sth = $dbh->prepare("SELECT NAME from molecules ORDER BY ID");
$sth->execute;
my $total = 0;
my @names;

while ( my $row = $sth->fetchrow_array )
  {
  $total ++;
  push @names, $row;
  }

$count = 0;

my $value = 0;
while ($value < $total)
  {
  $value = $value + $interval;
  if ( $value > $total )
    {
    $value = $total;
    }
  my @names_2 = undef;
  my %stereo_list = undef;
  my @stereos = undef;
  my $is_stereo = 0;
  foreach my $index (0..($value))
    {
    push @names_2, $names[$index];
    }
  foreach my $name_1 (@names_2)
    {
    $is_stereo = 0;
    #assume not stereo at first and check if there is a stereo pair including this name
    next if (! exists $test{$name_1});

    foreach my $name_2 (@names_2)
      {
      #now test if a pair includes name2 next if no pair has name 2
      next if (! exists $test{$name_2});
      # test if name1 name2 pair is a stereoisomer
      if ( exists $stereos{$name_1}{$name_2} )
        {
        $is_stereo = 1;

        }
      elsif ( exists $stereos{$name_2}{$name_1} ) #since we recorded name1,name2 and name2,name1 as paris this isn't necessary, just being safe
        {
        $is_stereo = 1;

        }
      }
    push @stereos, $name_1 if ($is_stereo == 1);
    $stereo_list{$name_1} = 1 if ($is_stereo == 1);
    }
  my $percent = ($#stereos+1)/$value * 100;
  print $value, " : ", $percent, "\n";
  }

$dbh->disconnect();
