#!/usr/bin/perl


#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014


use strict;
use warnings;
use DBI;

foreach my $SQLite_file (@ARGV)
  {
#  print $SQLite_file . "\n";
  my $dbh = DBI->connect("dbi:SQLite:dbname=$SQLite_file",'','',{AutoCommit=>0, RaiseError=>1});
  my $sth = $dbh->prepare("SELECT FORMULA from molecules"); #read all formulas order doesn't matter
  $sth->execute;
  my @result = $sth->fetchrow_array();
  my $formulas = [];
  while ( my $row = $sth->fetchrow_array )
    {
    push @$formulas, $row;
#    print $row , "\n";
    }
  my %counter;
  foreach my $formula (@$formulas) #count number of formulas
    {
    $counter{$formula}++;
    }

  my $total_compounds;
  my $total_formulas;
  my $isomeric_compounds;
  my $isomeric_formulas;
  my $non_isomeric_compounds;
  my $non_isomeric_formulas;


  foreach my $value (values %counter)
    {
    $total_compounds += $value;
    if ($value == 1) #was unique formula
      {
      $non_isomeric_compounds ++;
      $non_isomeric_formulas ++;
      $total_formulas ++;
      }
    elsif ($value > 1) #is not unique formula
      {
      $isomeric_compounds += $value;
      $isomeric_formulas ++;
      $total_formulas ++;
      }
    }

  print "FOR THE DATABASE: $SQLite_file THERE WERE:\n\n";
  print "$total_compounds TOTAL COMPOUNDS\n$total_formulas TOTAL FORMULAS\n\n$isomeric_compounds ISOMERIC COMPOUNDS\n$non_isomeric_compounds NON-ISOMERIC COMPOUNDS\n\n$isomeric_formulas ISOMERIC FORMULAS\n$non_isomeric_formulas NON-ISOMERIC FORMULAS\n";
  my $percent_iso_formulas = $isomeric_formulas / $total_formulas * 100;
  my $percent_iso_compounds = $isomeric_compounds / $total_compounds * 100;
  my $isomericity = $isomeric_compounds / $isomeric_formulas;
  print "\n$percent_iso_formulas % of FORMULAS ARE ISOMERIC\n$percent_iso_compounds % of COMPOUNDS ARE ISOMERIC\nEACH ISOMERIC FORMULAS HAS AN AVERAGE OF $isomericity COMPOUNDS\n\n\n";


  $dbh->disconnect();
  }


