#!/usr/bin/perl

#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014

use strict;
use warnings; 
use DBI;

my $prototype = shift @ARGV;
my @column_names;

open FILE, $prototype;
while (my $line = <FILE>)
  {
  my @array = split(/\&\&/, $line); #split into formula and fgroup / # pairs
  my $formula = shift @array; #remove formula
  foreach my $fgroup (@array) 
    {
    my ($group_name, $number) = split(/\.mol/, $fgroup);#remove .mol from files
    push @column_names, $group_name;
    print $group_name, "\n"; #this is just here to show it is working
    }
  } 
my $sqlite = shift @ARGV;
my $dbh = DBI->connect("dbi:SQLite:dbname=$sqlite",'','',{sqlite_use_immediate_transaction => 1});
foreach my $column_name (@column_names)
  {
  print $column_name, "\n";
  my $string = "ALTER TABLE molecules ADD '$column_name' INT DEFAULT '0'"; #add table for each group name
  $dbh->do($string);
  }
$dbh->disconnect;


