#!/usr/bin/perl

#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014

use strict;
use DBI;

my $results_dir = shift @ARGV;
my @results_ids;
my @results_files;
foreach my $file (glob("$results_dir*.out")) #get all files in directory
  {
  my @id = split(/$results_dir/, $file); #get name of file, which is its id
  $file = join('',$file);
  my $id = $id[1];
  $id =~ s/\.out//; #remove .our extension
  push @results_files, $file;
  push @results_ids, $id;
  }

my $sqlite = shift @ARGV;
my $dbh = DBI->connect("dbi:SQLite:dbname=$sqlite",'','',{RaiseError=>1,sqlite_use_immediate_transaction=>1});

foreach my $index (0..$#results_files)
  {
  my $file = $results_files[$index];
  my $id = $results_ids[$index];
  open FILE, $file; #read id file specified
  while (my $line = <FILE>)
    {
    my @array = split(/\&\&/, $line); #split into formula and group/# paris
    my $formula = shift @array; #get rid of formula dont' need it
    foreach my $element (@array)
      {
      my ($functional_name, $number) = split(/\.mol/,$element); #remove .mol
      next if ($number == 0); #no instances and the default value is zero no need for work
                              #this makes it a whole lot faster
      my $string = "UPDATE molecules SET '$functional_name' = '$number' WHERE ID = '$id'"; #record # of groups
      my $sth = $dbh->do($string);
      }
    }
  }
$dbh->disconnect;














