#!/usr/bin/perl

#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014

use lib '../MODULES';
use strict;
use warnings;
use DBI;
use MolFile;

my $sqlite = shift @ARGV;
my $fgroups_file = shift @ARGV;

my $dbh = DBI->connect("dbi:SQLite:dbname=$sqlite",'','',{sqlite_use_immediate_transaction => 1});
my $fgroups = (MolFile->new("File"=>$fgroups_file, "Type"=>'functional')->parse());

my $make_table = $dbh->prepare("CREATE TABLE functionals (NAME text, MOLFILE text, ID text)");
$make_table->execute();

my $insert_functional = $dbh->prepare("INSERT INTO functionals (NAME, MOLFILE, ID) values (?,?,?)");
foreach my $fgroup (values %$fgroups)
  {
  print $$fgroup{Name};
  $insert_functional->execute($$fgroup{Name}, $$fgroup{String}, $$fgroup{ID});
  }

$dbh->disconnect();
