#!/usr/bin/perl

#Bond.pm
#Contains the methods for Bond, an object that represents a chemical bond within a compound.


#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014

package Bond;
use base 'Class::Accessor::Fast';
use strict;
#use warnings;

#Create prototypical bond object
my @bond_fields = 
  (
  "Atom_1"     =>  0, #an integer representing the first atom of the bond
  "Atom_2"     =>  0, #an integer representing the second atom of the bond
  "Bond_order" =>  0, #an integer representing the order of bond 
  );

Bond->mk_accessors( grep { $_ ne "0"; } (@bond_fields) );

#Name: new
#Description: Creates a new 'bond' object
#Options: None
#Input: @_ - @(Atom_1, Atom_2, Bond_order)
#Output: $self - Bond Object

sub new 
  { 
  my $proto = shift @_;   
  my $self = {@bond_fields, @_};
  return bless ($self, ref($proto) || $proto);
  }

1;

