#!/usr/bin/perl
#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014
use strict;
use warnings;
use DBI;
use lib '../MODULES';

my $SQLite_file = shift @ARGV;
my $dbh = DBI->connect("dbi:SQLite:dbname=$SQLite_file",'','',{AutoCommit=>1, RaiseError=>1, sqlite_use_immediate_transaction=>1});

my $sth = $dbh->prepare("SELECT FORMULA from molecules");
$sth->execute;
my ($formulas, $potential_isomers) = ( [], [] );

while ( my $row = $sth->fetchrow_array )
  {
  push @$formulas, $row;
  }

my %counter;
foreach my $formula (@$formulas)
  {
  $counter{$formula}++;
  }

foreach my $key (keys %counter)
  {
  push @$potential_isomers, $key if ($counter{$key} > 1);
  }

mkdir( "TEMP_SQL" ) unless (-e "./TEMP_SQL");
my @jobs;

OUTER: foreach my $formula (@$potential_isomers)
  {
  $sth = $dbh->prepare("SELECT ID from molecules WHERE FORMULA = '$formula'"); #get compound IDs with same formula
  $sth->execute;
  my @pot_isomer_IDs;
  while ( my $row = $sth->fetchrow_array )
    {
    push @pot_isomer_IDs, $row; 
    } 
  my $index = @pot_isomer_IDs;
  foreach my $i (0..$#pot_isomer_IDs)
    {
    foreach my $j ($i+1..$#pot_isomer_IDs)
      {
      print "$pot_isomer_IDs[$i]:$pot_isomer_IDs[$j]\n"; #list all pairs to be tested wihtout duplicate pairs
      }
    }  
  }
die;
$dbh->disconnect();
undef($dbh);
