#!/usr/bin/perl
#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014
use strict;

open FILE, shift @ARGV;
my %functionals;
my $count = 0;
my $depth = -1;
while ( my $line = <FILE> )
  {
  chomp $line;
  if ( $line =~ /\d+\s+\w*/ )
    {
    my ($index, $functional) = ( $line =~ /(\d+)\s+(\w+.*)/ );
    $functional =~ s/^\s+//;
    $functional =~ s/\s+$//;
    $functional =~ s/SUPER//;
    $functionals{$index} = $functional;
    }
  elsif ( $line =~ /Strategy Depth/ ) 
    {
    $depth ++;
    $count = 1;
    }
  elsif ( $line =~ /SORTING/ and $count == 1 )
    {
    $count = 2;
    next;
    }
  elsif ( $count == 2 and $line =~ /,/ )
    {
    next if !($depth == 3 or $depth == 5 or $depth == 10 or $depth == 15);
    my $list = $line;
    my @array = split(/,/,$list);
    my $percent = pop @array;
    my $junk = shift @array;
    my @functionals = map { $functionals{$_} } ( @array);
    print "$depth :: $percent :: ", join(', ',@functionals), "\n";
#    foreach my $entry (@array)
#      {
#      print $functionals{$entry}, ",";
#      }


    $count = 0;
    }
  }
