#!/usr/bin/perl
#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014
use strict;
use DBI;

my $file = shift @ARGV;
open FILE, $file; #this is list of name translations. 
my @names1;
my @names2;

while (my $line = <FILE>)
  {
  chomp $line;
  my @array = split(/\$\$\$\$/, $line);
  my $name1 = $array[0];
  my $name2 = $array[1];
  push @names1, $name1;
  push @names2, $name2;
  }
close FILE;

my $SQL_h = shift @ARGV;
my $option = shift @ARGV; #specify kegg or hmdb. 
my $dbh = DBI->connect("dbi:SQLite:dbname=$SQL_h",'','',{sqlite_use_immediate_transaction=>1});


foreach my $name1 (@names1)
  {
  last if $option ne "HMDB";
  my $sth = $dbh->prepare("SELECT ID from molecules WHERE NAME = (?)");
  $sth->execute($name1);
  my $id = $sth->fetchrow_array;
  $name1 = $name1 . ";";
  print $id, "\n";
  }

foreach my $name2 (@names2)
  {
  last if $option ne "KEGG";
  my $sth = $dbh->prepare("SELECT ID from molecules WHERE NAME = (?)");
  $sth->execute($name2);
  my $id = $sth->fetchrow_array;
  $name2 = $name2 . ";";
  $sth->execute($name2);
  my $id2 = $sth->fetchrow_array;
  print $id, $id2, "\n";
  }
