#!/usr/bin/perl
#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014
use strict;
use warnings;

my $file = shift @ARGV;
open FILE, $file;

my @names;
my $flag = 0;
my $array = [];
while (my $line = <FILE>)
  {
  $line = substr $line, 1;
  if ($line =~ /Compound/)
    {
    push @names, $array if ($#$array != -1); #get all names in kcf for file
#    print join(" : ", @$array), "\n" if ($#$array != -1);;
    $array = [];
    $flag = 0
    }
  elsif ($line =~ /NAME/ and $flag == 0)
    {
    $flag = 1;
    my ($name) = ($line =~  /NAME\s+(.*);?/);
    $name =~ s/;//; #remove semi colon
    push @$array,  $name;
#    print $name, "\n";
    }
  elsif ($line =~ /FORMULA/)
    {
    push @names, $array if ($#$array != -1); #found all names put it on list of names
#    print join(" : ", @$array), "\n" if ($#$array != -1);;
    $array = [];
    $flag = 0;
    }
  elsif ($flag == 1)
    {
    my ($name) = ($line =~ /\s+(.*)?/); #get name of compound without complete kcf file (like some peptide entries)
    $name =~ s/;//;
    push @$array,  $name;
#    print "\t$name\n";
    }
  else 
    {
    push @names, $array if ($#$array != -1);
#    print join(" : ", @$array), "\n" if ($#$array != -1);
    $array = [];
    $flag = 0;
    }
  }

use DBI;
my $sql = shift @ARGV;
my $dbh = DBI->connect("dbi:SQLite:dbname=$sql",'','',{sqlite_use_immediate_transaction=>1});
my $sth = $dbh->prepare("SELECT NAME from molecules"); #get all hmdb names
$sth->execute;
my @hmdb_names;
while ( my $row = $sth->fetchrow_array )
  {
  push @hmdb_names, $row;
  }
#print join("\n", @hmdb_names), "\n";
my $count = 0;
foreach my $hmdb (@hmdb_names)
  {
  $count ++;
  print STDERR $count, "\n";
  my $name_h = lc $hmdb; 
  foreach my $array (@names)
    {
    my $same = grep( { lc $_ eq $name_h; } (@$array)); #compare hmdb name to all keg names for all kegg compounds, if there is a match they are duplicates
    if ($same > 0)
      {
      print $hmdb, "\$\$\$\$", $$array[0], "\$\$\$\$NAME$count\n";
      }
#    print $same, "\n";
    }
  }  
