#!/usr/bin/perl
#       Copyright Joshua M. Mitchell and Hunter N.B. Moseley, 2014. All rights reserved.
#       Written by Joshua Mitchell 5/1/2014
use strict;
use warnings;
use DBI;

my $kegg_sql = shift @ARGV;
my $hmdb_sql = shift @ARGV;

my $dbh_kegg = DBI->connect("dbi:SQLite:dbname=$kegg_sql",'','',{sqlite_use_immediate_transaction=>1});
my $dbh_hmdb = DBI->connect("dbi:SQLite:dbname=$hmdb_sql",'','',{sqlite_use_immediate_transaction=>1});

my $sth = $dbh_kegg->prepare("SELECT ID from molecules");
$sth->execute;
my @kegg_ids;
while ( my $row = $sth->fetchrow_array )
  {
  push @kegg_ids, $row;
  }

my $count = 0;
foreach my $id (@kegg_ids)
  {
  $count ++;
  my $sth = $dbh_kegg->prepare("SELECT FORMULA from molecules WHERE ID = '$id'");
  $sth->execute;
  while ( my $formula = $sth->fetchrow_array )
    {
    my $sth_2 = $dbh_hmdb->prepare("SELECT ID from molecules WHERE FORMULA = '$formula'");
    $sth_2->execute;
    while ( my $id2 = $sth_2->fetchrow_array )
      {
      print $id,":",$id2,"\n";
      }
    }
  }
